package Linode::Longview::DataGetter::CPU;

use Linode::Longview::Util qw(jiffies2Percent slurp_file delta $procfs);

use Exporter 'import';
our @EXPORT_OK = (qw(get));

sub get {
	my $dataref = shift;
	my $ts = time;
	my @statFile = slurp_file( $procfs . 'stat' ) or return;
	shift @statFile;    #first line is combined, pitch it
	foreach my $line (@statFile) {
		last unless $line =~ m/^(cpu\d+)\s+/;
		my ( $user, $nice, $system, $idle, $wait )
			= ( split /\s+/, $line )[ 1 .. 5 ];
		$dataref->{LONGTERM}->{"CPU.$1.user"} = $user + $nice;
		$dataref->{LONGTERM}->{"CPU.$1.system"} = $system + 0;
		$dataref->{LONGTERM}->{"CPU.$1.wait"} = $wait + 0;
	}
	close($ps);
	return $dataref;
}

1;
