package Linode::Longview::DataGetter::Memory;

use Exporter;
@ISA       = qw(Exporter);
@EXPORT_OK = qw(get);

use Linode::Longview::Util qw(slurp_file $procfs);

sub get {
	my $dataref = shift;
	my $meminfo = slurp_file( $procfs . 'meminfo' )
		or die "Couldn't read ${procfs}meminfo: $!";

	# We need to "numify" these matches to make JSON::PP not-quote
	( $dataref->{LONGTERM}->{"Memory.real.free"} )    = ( $meminfo =~ /MemFree:\s+(\d+)/ )[0] + 0;
	( $dataref->{LONGTERM}->{"Memory.real.buffers"} ) = ( $meminfo =~ /Buffers:\s+(\d+)/ )[0] + 0;
	( $dataref->{LONGTERM}->{"Memory.real.cache"} )   = ( $meminfo =~ /Cached:\s+(\d+)/ )[0] + 0;
	( $dataref->{LONGTERM}->{"Memory.real.used"} )
		= ( $meminfo =~ /MemTotal:\s+(\d+)/ )[0]
		- ( $meminfo =~ /MemFree:\s+(\d+)/ )[0];
	( $dataref->{LONGTERM}->{"Memory.swap.used"} )
		= ( $meminfo =~ /SwapTotal:\s+(\d+)/ )[0]
		- ( $meminfo =~ /SwapFree:\s+(\d+)/ )[0];
	( $dataref->{LONGTERM}->{"Memory.swap.free"} ) = ( $meminfo =~ /SwapFree:\s+(\d+)/ )[0] + 0;
	return $dataref;
}

1;
