package Linode::Longview::DataGetter::Packages;

use Linode::Longview::DataGetter::Packages::APT;
use Linode::Longview::DataGetter::Packages::YUM;
use Linode::Longview::DataGetter::Packages::unknown;

use Linux::Distribution qw(distribution_name);

use Exporter 'import';
our @EXPORT_OK = (qw(get));

sub get {
	my $dataref = shift;
	my $pkgTool = determinePkgTool();
	my $ret = eval "Linode::Longview::DataGetter::Packages::${pkgTool}::get(\${dataref})";
	warn $@ if $@;
	return $ret;
}

sub determinePkgTool {
	my $dist = distribution_name();
	return 'APT' if ( $dist eq 'debian' || $dist eq 'ubuntu' );
	return 'YUM' if ( $dist eq 'centos' || $dist eq 'fedora' );
	return 'unknown';
}

1;
