package Linode::Longview::DataGetter::Packages::YUM;

use Exporter 'import';
our @EXPORT_OK = (qw(get));

sub get {
	my $dataref = shift;
	my %uPkgs = upgradablePkgs();
	return $dataref unless %uPkgs;
	my %cPkgs = currentPkgs();
	my @ret = map { { name => $_, current => $cPkgs{$_}, new => $uPkgs{$_} } }
		keys %uPkgs;
	$dataref->{SYSINFO}->{Packages} = \@ret;
	return $dataref;
}

sub currentPkgs {

	# yum wraps unless we fake tty
	my @pkgList = qx(script -c "yum --color=never list installed" /dev/null);
	my %pkgs;
	foreach my $pkg (@pkgList) {
		if ( $pkg =~ m/^(.*?)\s+(.*?)\s+@(.*)$/ ) {
			$pkgs{$1} = $2;
		}
	}
	return %pkgs;
}

sub upgradablePkgs {
	my @pkgList = qx(yum check-update);
	my %pkgs;
	foreach my $pkg (@pkgList) {
		if ( $pkg =~ m/^(\S+)\s+(\S+)\s+\S+$/ ) {
			$pkgs{$1} = $2;
		}
	}
	return %pkgs;
}

1;
